--
-- silage mode on/off
--
-- 06/08/09 guimchevalier from TSF3 www.tsforum3.com 
--
-- Edited by: Saroman93


leffers = {};

function leffers.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Trailer, specializations);
end;

function leffers:load(xmlFile)

	
	-- graincurve when extension is stock
    self.stock = {};
	self.stock.capacity = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.extension.stock#capacity"), 0);
	local grainAnimCurve = AnimCurve:new(linearInterpolator4);
	local keyI = 0;
	while true do
		local key = string.format("vehicle.extension.stock.key(%d)", keyI);
		local t = getXMLFloat(xmlFile, key.."#time");
		local yValue = getXMLFloat(xmlFile, key.."#y");
		local scaleX,scaleY,scaleZ = Utils.getVectorFromString(getXMLString(xmlFile, key.."#scale"));
		if y == nil or scaleX == nil or scaleY == nil or scaleZ == nil then
			break;
		end;
		grainAnimCurve:addKeyframe({x=scaleX, y=scaleY, z=scaleZ, w=yValue, time = t});
		keyI = keyI +1;
	end;
	if keyI > 0 then
		self.stock.grainAnimCurve = grainAnimCurve;
	end;
	
	
	-- graincurve when extension is half
    self.step1 = {};
	self.step1.capacity = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.extension.step1#capacity"), 0);
	local grainAnimCurve = AnimCurve:new(linearInterpolator4);
	local keyI = 0;
	while true do
		local key = string.format("vehicle.extension.step1.key(%d)", keyI);
		local t = getXMLFloat(xmlFile, key.."#time");
		local yValue = getXMLFloat(xmlFile, key.."#y");
		local scaleX,scaleY,scaleZ = Utils.getVectorFromString(getXMLString(xmlFile, key.."#scale"));
		if y == nil or scaleX == nil or scaleY == nil or scaleZ == nil then
			break;
		end;
		grainAnimCurve:addKeyframe({x=scaleX, y=scaleY, z=scaleZ, w=yValue, time = t});
		keyI = keyI +1;
	end;
	if keyI > 0 then
		self.step1.grainAnimCurve = grainAnimCurve;
	end;
	
	self.extensionStep1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.extensions#index"));
	self.extensionBack = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.extensions#back"));
	-- first start	
	self.extension = 1;
	self.capacity = self.stock.capacity;
	self.grainAnimCurve = self.stock.grainAnimCurve;
end;

function leffers:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
	local fillLevel = getXMLFloat(xmlFile, key.."#fillLevel");
    local fillType = getXMLString(xmlFile, key.."#fillType");
    self.extension =  getXMLFloat(xmlFile, key.."#extension");
		if self.extension == 0 then
			self.capacity = self.stock.capacity;
			self.grainAnimCurve = self.stock.grainAnimCurve;
		end;
		if self.extension == 1 then
			self.capacity = self.step1.capacity;
			self.grainAnimCurve = self.step1.grainAnimCurve;
		end;
    if fillLevel ~= nil and fillType ~= nil then
        local fillTypeDesc = FruitUtil.fruitTypes[fillType];
        if fillTypeDesc ~= nil then
            self:setFillLevel(fillLevel, fillTypeDesc.index);
        end;
    end;
    return BaseMission.VEHICLE_LOAD_OK;
end;

function leffers:getSaveAttributesAndNodes(nodeIdent)
	local stocktext='error';
	if self.extension == 0 then
		stocktext='0';
	end;
	if self.extension == 1 then
		stocktext='1';
	end;   
	
	local attributes = 'extension="'..stocktext..'"';
   return attributes, nil;
end;

function leffers:delete()

end;

function leffers:mouseEvent(posX, posY, isDown, isUp, button)

end;

function leffers:keyEvent(unicode, sym, modifier, isDown)
end;

function leffers:update(dt)
	--capacity grainplane


    if self.extension == 0 then
		    self.capacity = self.stock.capacity;
	        self.grainAnimCurve = self.stock.grainAnimCurve;	
	        setVisibility(self.extensionStep1, false);	
		    setVisibility(self.extensionBack, false);
	end;
    if self.extension == 1 then
			self.capacity = self.step1.capacity;
			self.grainAnimCurve = self.step1.grainAnimCurve;
		    setVisibility(self.extensionStep1, true);	
		    setVisibility(self.extensionBack, true);
	end;
    if self:getIsActiveForInput() then	
	    if self.fillLevel == 0  and InputBinding.hasEvent(InputBinding.leffers_extension) then
		    self.extension = self.extension +1
			if self.extension > 1 then
			    self.extension = 0
			end;
        end;
	end;
	
end;

function leffers:draw()
    if self.attacherVehicle then
	    if self.fillLevel == 0 and self.extension == 0 then
	        g_currentMission:addHelpButtonText(g_i18n:getText("change_to_extension1"), InputBinding.leffers_extension);
		end;
		if self.fillLevel == 0 and self.extension == 1 then
	        g_currentMission:addHelpButtonText(g_i18n:getText("change_to_extension0"), InputBinding.leffers_extension);
		end;
	end;
end;

function leffers:onDetach()
end;

function leffers:onAttach()
end;

function leffers:onStartTip(currentTipTrigger)

    g_currentMission.fixedCamera = false;
end;